## dblink\_connect

dblink\_connect — opens a persistent connection to a remote database

## Synopsis

```
dblink_connect(text connstr) returns text
dblink_connect(text connname, text connstr) returns text

```

## Description

`dblink_connect()` establishes a connection to a remote PostgreSQL database. The server and database to be contacted are identified through a standard libpq connection string. Optionally, a name can be assigned to the connection. Multiple named connections can be open at once, but only one unnamed connection is permitted at a time. The connection will persist until closed or until the database session is ended.

 The connection string may also be the name of an existing foreign server. It is recommended to use the foreign-data wrapper `dblink_fdw` when defining the foreign server. See the example below, as well as [CREATE SERVER](sql-createserver.html) and [CREATE USER MAPPING](sql-createusermapping.html).

## Arguments

*`connname`*

 The name to use for this connection; if omitted, an unnamed connection is opened, replacing any existing unnamed connection.

*`connstr`*

libpq-style connection info string, for example `hostaddr=127.0.0.1 port=5432 dbname=mydb user=postgres password=mypasswd options=-csearch_path=`. For details see [Section 34.1.1](libpq-connect.html#LIBPQ-CONNSTRING). Alternatively, the name of a foreign server.

## Return Value

 Returns status, which is always `OK` (since any error causes the function to throw an error instead of returning).

## Notes

 If untrusted users have access to a database that has not adopted a [secure schema usage pattern](ddl-schemas.html#DDL-SCHEMAS-PATTERNS), begin each session by removing publicly-writable schemas from `search_path`. One could, for example, add `options=-csearch_path=` to *`connstr`*. This consideration is not specific to `dblink`; it applies to every interface for executing arbitrary SQL commands.

 Only superusers may use `dblink_connect` to create non-password-authenticated connections. If non-superusers need this capability, use `dblink_connect_u` instead.

 It is unwise to choose connection names that contain equal signs, as this opens a risk of confusion with connection info strings in other `dblink` functions.

## Examples

```
SELECT dblink_connect('dbname=postgres options=-csearch_path=');
 dblink_connect
